Loading...
Searching...
No Matches
Opm::Simulator< TypeTag > Class Template Reference

Manages the initializing and running of time dependent problems. More...

`#include <simulator.hh>`

## Public Member Functions

| Simulator (const Simulator &)=delete
| Simulator (bool verbose=true)
| Simulator (Communication comm, bool verbose=true)
Vanguard & | vanguard ()
| Return a reference to the grid manager of simulation.
const Vanguard & | vanguard () const
| Return a reference to the grid manager of simulation.
const GridView & | gridView () const
| Return the grid view for which the simulation is done.
Model & | model ()
| Return the physical model used in the simulation.
const Model & | model () const
| Return the physical model used in the simulation.
Problem & | problem ()
| Return the object which specifies the pysical setup of the simulation.
const Problem & | problem () const
| Return the object which specifies the pysical setup of the simulation.
void | setStartTime (Scalar t)
| Set the time of the start of the simulation.
Scalar | startTime () const
| Return the time of the start of the simulation.
void | setTime (Scalar t)
| Set the current simulated time, don't change the current time step index.
void | setTime (Scalar t, unsigned stepIdx)
| Set the current simulated time and the time step index.
Scalar | time () const
| Return the number of seconds of simulated time which have elapsed since the start time.
void | setEndTime (Scalar t)
| Set the time of simulated seconds at which the simulation runs.
Scalar | endTime () const
| Returns the number of (simulated) seconds which the simulation runs.
const Timer & | setupTimer () const
| Returns a reference to the timer object which measures the time needed to set up and initialize the simulation.
const Timer & | executionTimer () const
| Returns a reference to the timer object which measures the time needed to run the simulation.
Timer & | executionTimer ()
const Timer & | prePostProcessTimer () const
| Returns a reference to the timer object which measures the time needed for pre- and postprocessing of the solutions.
const Timer & | linearizeTimer () const
| Returns a reference to the timer object which measures the time needed for linarizing the solutions.
const Timer & | solveTimer () const
| Returns a reference to the timer object which measures the time needed by the solver.
const Timer & | updateTimer () const
| Returns a reference to the timer object which measures the time needed to the solutions of the non-linear system of equations.
const Timer & | writeTimer () const
| Returns a reference to the timer object which measures the time needed to write the visualization output.
void | setTimeStepSize (Scalar value)
| Set the current time step size to a given value.
void | setTimeStepIndex (unsigned value)
| Set the current time step index to a given value.
Scalar | timeStepSize () const
| Returns the time step length so that we don't miss the beginning of the next episode or cross the end of the simlation.
int | timeStepIndex () const
| Returns number of time steps which have been executed since the beginning of the simulation.
void | setFinished (bool yesno=true)
| Specify whether the simulation is finished.
bool | finished () const
| Returns true if the simulation is finished.
bool | willBeFinished () const
| Returns true if the simulation is finished after the time level is incremented by the current time step size.
Scalar | maxTimeStepSize () const
| Aligns the time step size to the episode boundary and to the end time of the simulation.
void | startNextEpisode (Scalar episodeStartTime, Scalar episodeLength)
| Change the current episode of the simulation.
void | startNextEpisode (Scalar len=std::numeric_limits< Scalar >::max())
| Start the next episode, but don't change the episode identifier.
void | setEpisodeIndex (int episodeIdx)
| Sets the index of the current episode.
int | episodeIndex () const
| Returns the index of the current episode.
Scalar | episodeStartTime () const
| Returns the absolute time when the current episode started .
void | setEpisodeLength (Scalar dt)
| Sets the length in seconds of the current episode.
Scalar | episodeLength () const
| Returns the length of the current episode in simulated time .
bool | episodeStarts () const
| Returns true if the current episode has just been started at the current time.
bool | episodeIsOver () const
| Returns true if the current episode is finished at the current time.
bool | episodeWillBeOver () const
| Returns true if the current episode will be finished after the current time step.
Scalar | episodeMaxTimeStepSize () const
| Aligns the time step size to the episode boundary if the current time step crosses the boundary of the current episode.
void | run ()
| Runs the simulation using a given problem class.

## Static Public Member Functions

static void | registerParameters ()
| Registers all runtime parameters used by the simulation.

## Saving/restoring the simulation state

void | serialize ()
| This method writes the complete state of the simulation to the harddisk.
template<class Restarter>
void | serialize (Restarter &restarter)
| Write the time manager's state to a restart file.
template<class Restarter>
void | deserialize (Restarter &restarter)
| Read the time manager's state from a restart file.
template<class Serializer>
void | serializeOp (Serializer &serializer)

## Detailed Description

template<class TypeTag>
class Opm::Simulator< TypeTag >

Manages the initializing and running of time dependent problems.

This class instantiates the grid, the model and the problem to be simlated and runs the simulation loop. The time axis is treated as a sequence of "episodes" which are defined as time intervals for which the problem exhibits boundary conditions and source terms that do not depend on time.

## Member Function Documentation

## deserialize()

template<class TypeTag>
template<class Restarter>

void Opm::Simulator< TypeTag >::deserialize | ( | Restarter & | restarter | ) |

inline

Read the time manager's state from a restart file.

Template Parameters

  Restarter | The type of the object which takes care to deserialize data

Parameters

  restarter | The deserializer object

## episodeIndex()

template<class TypeTag>

int Opm::Simulator< TypeTag >::episodeIndex | ( |  | ) | const

inline

Returns the index of the current episode.

The first episode has the index 0.

## finished()

template<class TypeTag>

bool Opm::Simulator< TypeTag >::finished | ( |  | ) | const

inline

Returns true if the simulation is finished.

This is the case if either setFinished(true) has been called or if the end time is reached.

## run()

template<class TypeTag>

void Opm::Simulator< TypeTag >::run | ( |  | ) |

inline

Runs the simulation using a given problem class.

This method makes sure that time steps sizes are aligned to episode boundaries, amongst other stuff.

## serialize() [1/2]

template<class TypeTag>

void Opm::Simulator< TypeTag >::serialize | ( |  | ) |

inline

This method writes the complete state of the simulation to the harddisk.

The file will start with the prefix returned by the name() method, has the current time of the simulation clock in it's name and uses the extension .ers. (Ewoms ReStart file.) See Opm::Restart for details.

## serialize() [2/2]

template<class TypeTag>
template<class Restarter>

void Opm::Simulator< TypeTag >::serialize | ( | Restarter & | restarter | ) |

inline

Write the time manager's state to a restart file.

Template Parameters

  Restarter | The type of the object which takes care to serialize data

Parameters

  restarter | The serializer object

## setEndTime()

template<class TypeTag>

void Opm::Simulator< TypeTag >::setEndTime | ( | Scalar | t | ) |

inline

Set the time of simulated seconds at which the simulation runs.

Parameters

  t | The time at which the simulation is finished

## setEpisodeIndex()

template<class TypeTag>

void Opm::Simulator< TypeTag >::setEpisodeIndex | ( | int | episodeIdx | ) |

inline

Sets the index of the current episode.

Use this method with care!

## setEpisodeLength()

template<class TypeTag>

void Opm::Simulator< TypeTag >::setEpisodeLength | ( | Scalar | dt | ) |

inline

Sets the length in seconds of the current episode.

Use this method with care!

## setFinished()

template<class TypeTag>

void Opm::Simulator< TypeTag >::setFinished | ( | bool | yesno = true | ) |

inline

Specify whether the simulation is finished.

Parameters

  yesno | If true the simulation is considered finished before the end time is reached, else it is only considered finished if the end time is reached.

## setStartTime()

template<class TypeTag>

void Opm::Simulator< TypeTag >::setStartTime | ( | Scalar | t | ) |

inline

Set the time of the start of the simulation.

Parameters

  t | The time which should be jumped to

## setTime() [1/2]

template<class TypeTag>

void Opm::Simulator< TypeTag >::setTime | ( | Scalar | t | ) |

inline

Set the current simulated time, don't change the current time step index.

Parameters

  t | The time which should be jumped to

## setTime() [2/2]

template<class TypeTag>

void Opm::Simulator< TypeTag >::setTime | ( | Scalar | t,
|  | unsigned | stepIdx )

inline

Set the current simulated time and the time step index.

Parameters

  t | The time which should be jumped to
  stepIdx | The new time step index

## setTimeStepIndex()

template<class TypeTag>

void Opm::Simulator< TypeTag >::setTimeStepIndex | ( | unsigned | value | ) |

inline

Set the current time step index to a given value.

Parameters

  value | The new value for the time step index

## setTimeStepSize()

template<class TypeTag>

void Opm::Simulator< TypeTag >::setTimeStepSize | ( | Scalar | value | ) |

inline

Set the current time step size to a given value.

If the step size would exceed the length of the current episode, the timeStep() method will take care that the step size won't exceed the episode or the end of the simulation, though.

Parameters

  value | The new value for the time step size

## startNextEpisode() [1/2]

template<class TypeTag>

void Opm::Simulator< TypeTag >::startNextEpisode | ( | Scalar | episodeStartTime,
|  | Scalar | episodeLength )

inline

Change the current episode of the simulation.

Parameters

  episodeStartTime | Time when the episode began
  episodeLength | Length of the episode

## startNextEpisode() [2/2]

template<class TypeTag>

void Opm::Simulator< TypeTag >::startNextEpisode | ( | Scalar | len = std::numeric_limits<Scalar>::max() | ) |

inline

Start the next episode, but don't change the episode identifier.

Parameters

  len | Length of the episode , infinite if not specified.

## time()

template<class TypeTag>

Scalar Opm::Simulator< TypeTag >::time | ( |  | ) | const

inline

Return the number of seconds of simulated time which have elapsed since the start time.

To get the time after the time integration, you have to add timeStepSize() to time().

The documentation for this class was generated from the following file:

- opm/models/utils/simulator.hh